/* Copyright Statement:
 *
 * This software/firmware and related documentation ("AutoChips Software") are
 * protected under relevant copyright laws. The information contained herein is
 * confidential and proprietary to AutoChips Inc. and/or its licensors. Without
 * the prior written permission of AutoChips inc. and/or its licensors, any
 * reproduction, modification, use or disclosure of AutoChips Software, and
 * information contained herein, in whole or in part, shall be strictly
 * prohibited.
 *
 * AutoChips Inc. (C) 2024. All rights reserved.
 *
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("AUTOCHIPS SOFTWARE")
 * RECEIVED FROM AUTOCHIPS AND/OR ITS REPRESENTATIVES ARE PROVIDED TO RECEIVER
 * ON AN "AS-IS" BASIS ONLY. AUTOCHIPS EXPRESSLY DISCLAIMS ANY AND ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NONINFRINGEMENT. NEITHER DOES AUTOCHIPS PROVIDE ANY WARRANTY WHATSOEVER WITH
 * RESPECT TO THE SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY,
 * INCORPORATED IN, OR SUPPLIED WITH THE AUTOCHIPS SOFTWARE, AND RECEIVER AGREES
 * TO LOOK ONLY TO SUCH THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO.
 * RECEIVER EXPRESSLY ACKNOWLEDGES THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO
 * OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES CONTAINED IN AUTOCHIPS
 * SOFTWARE. AUTOCHIPS SHALL ALSO NOT BE RESPONSIBLE FOR ANY AUTOCHIPS SOFTWARE
 * RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND AUTOCHIPS'S
 * ENTIRE AND CUMULATIVE LIABILITY WITH RESPECT TO THE AUTOCHIPS SOFTWARE
 * RELEASED HEREUNDER WILL BE, AT AUTOCHIPS'S OPTION, TO REVISE OR REPLACE THE
 * AUTOCHIPS SOFTWARE AT ISSUE, OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE
 * CHARGE PAID BY RECEIVER TO AUTOCHIPS FOR SUCH AUTOCHIPS SOFTWARE AT ISSUE.
 */
/******************************************************************************
 * @version: V3.1.0  AC7840x  Demo
 ******************************************************************************/

#include "ac7840x.h"
#include "debugout_ac7840x.h"
#include "ckgen_hw.h"
#include "ckgen_drv.h"
#include "clock_config.h"
#include "port_hw.h"
#include "gpio_hw.h"
#include "timer_sample.h"
#include "osif.h"

#include <math.h>
#include "arm_math.h"


/*!
 *例程说明：
 *1、分别使用内嵌DSP和M4内核计算三角函数200000次，比较两者的运算时间
 */

#define	DELTA   0.0001f /* 误差值 */

extern uint32_t g_res;

/*!
 * @brief 时钟配置函数.
 *
 * @param[in] none
 *
 * @return none
 */
void SystemClock_Config(void)
{
    CKGEN_SYS_Init(g_clockManConfigsArr, CLOCK_MANAGER_CONFIG_CNT,
                   g_clockManCallbacksArr, CLOCK_MANAGER_CALLBACK_CNT);
    CKGEN_DRV_UpdateConfiguration(0, CLOCK_MANAGER_POLICY_AGREEMENT);
}

/*!
 * sin_cos_test
 *    
 * @param[in]  none
 * @return 0 or 0XFF
 *
 * @brief  时钟配置函数
 */

uint8_t sin_cos_test(float angle,uint32_t times,uint8_t mode)
{
    float sinx,cosx;
    float result;
    uint32_t i=0;
    if(mode==0)
    {
        for(i=0;i<times;i++)
        {
            cosx=cosf(angle);   /*不使用DSP优化的sin，cos函数*/
            sinx=sinf(angle);
            result=sinx*sinx+cosx*cosx; /*计算结果应该等于1  */
            result=fabsf(result-1.0f);	/*对比与1的差值 */
            if(result>DELTA)return 0XFF;/*判断失败 */
            angle+=0.001f;  /*角度自增*/
        }
    }else
    {
        for(i=0;i<times;i++)
        {
            cosx=arm_cos_f32(angle);    /*使用DSP优化的sin，cos函数*/
            sinx=arm_sin_f32(angle);
            result=sinx*sinx+cosx*cosx; /*计算结果应该等于1  */
            result=fabsf(result-1.0f);    /*对比与1的差值 */
            if(result>DELTA)return 0XFF;/*判断失败 */
            angle+=0.001f;  /*角度自增  */
        }
    }
    return 0;//任务完成
} 
/*!
 * @brief main
 *
 * @param[in]  none
 *
 * @return 0: success, other: error value
 */
int main(void)
{
    
    SystemClock_Config();

    InitDebug();

    TIMER_Config();


    while(1)
    {
        g_res=0;
        sin_cos_test(PI/6,200000,0);    
        printf(" NO DSP RUNtimer =%d ms \r\n",g_res);
        g_res=0;
        sin_cos_test(PI/6,200000,1);
        printf(" USE DSP RUNtimer = %d ms \r\n",g_res);

        OSIF_TimeDelay(1000);
    }

}

